/*
Demonstration of fast quadrature decoder using RP2040 (PicoPi)

2024-03-13
Michael Nowak
http://www.mino-elektronik.de
Alle Angaben ohne Gewaehr !
*/

#ifdef __cplusplus
extern "C" {
#endif
// channel 0
void init_qcnt0(int);
void preload_qcnt0_val(int);
int  get_qcnt0(void);
int  read_qcnt0(void);
void preset_qcnt0(int);
void set_index0_pol(int);
// channel 1
void init_qcnt1(int);
void preload_qcnt1_val(int);
int  get_qcnt1(void);
int  read_qcnt1(void);
void preset_qcnt1(int);
void set_index1_pol(int);
#ifdef __cplusplus
}
#endif
static int temp_q_cnt, q_cnt;

void setup() {
  Serial.begin(12345);
  init_qcnt1(0);                       // preload value = 0
//  set_index1_pol(1);
}

void loop() {
  q_cnt = read_qcnt1();               // read
  if(q_cnt != temp_q_cnt)  {          // compare new != old
    temp_q_cnt = q_cnt;               // old = new 
    Serial.println(q_cnt * 0.01, 2);  // scaled output via USB
  }
  delay(10);
}
